<template>
  <div :class="classes" class="control keywords-container form-control">
    <div
      v-for="tag of tags"
      :key="tag"
      class="keyword"
    >
      {{ tag }}
      <b-icon-x
        scale="1.4"
        @click="removeKeyword(tag)"
      />
    </div>
    <div
      v-if="!isAddingKeyword"
      class="keyword add"
      @click="showKeywordInput"
    >
       <b-icon-plus scale="1.5" />
    </div>
    <input
      v-else
      v-model="newKeyword"
      ref="keywordInput"
      @keydown.enter.prevent.stop="addKeyword"
      @blur="addKeyword"
    >
  </div>
</template>

<script>
export default {
  name: 'Keywords',

  props: {
    tags: {
      type: Array,
      default: () => { return [] }
    },
    classes: {
      type: Object,
      default: () => { 
        return {
          valid: 'is-valid',
          invalid: 'is-invalid'
        }
      }
    }
  },

  data() {
    return {
      isAddingKeyword: false,
      newKeyword: ''
    }
  },

  watch: {
    tags: {
      deep: true,
      handler(newValue) {
        this.$emit('update', newValue);
      }
    }
  },

  methods: {
    showKeywordInput() {
      this.isAddingKeyword = true;
      this.$nextTick(() => {
        this.$refs.keywordInput.focus();
      });
    },

    addKeyword() {
      if (this.newKeyword && /(.|\s)*\S(.|\s)*/.test(this.newKeyword) && /[a-zA-Z]/.test(this.newKeyword)) {
        this.tags.push(this.newKeyword);
      }
      this.isAddingKeyword = false;
      this.newKeyword = null;
    },
    removeKeyword(tag) {
      const index = this.tags.findIndex(el => el === tag);
      this.tags.splice(index, 1);
    }
  }
}
</script>

<style lang="less" scoped>
.keywords-container {
  display: flex;
  flex-flow: row wrap;
  justify-content: flex-start;
  padding: 5px;
  height: fit-content;

  input {
    border: 2px solid #b4b9be;
    border-radius: 5px;
  }

  .keyword {
    background-color: @blue;
    color: white;
    opacity: 0.6;
    margin: 0.3em 0.2em;
    padding: 0.1em 0.5em;
    border-radius: 12px;
    font-weight: 500;
    .b-icon {
      cursor: pointer;
      margin-left: 0.2em;
    }
    .b-icon:hover {
      font-weight: bold;
    }
  }
  .keyword:hover {
    opacity: 0.8;
  }
  .add {
    opacity: 0.8;
  }
  .add:hover {
    cursor: pointer;
    opacity: 0.9;
  }
}

.keywords-container.is-valid {
  border: 2px #078b40 solid;
}
.keywords-container.is-invalid {
  border: 2px #EB0600 solid;
}
</style>
